/*
 * Fixed-precision arithmetic header
 */

typedef struct {
    int sign;
    int len;
    unsigned short s[PREC];
} znumber;
typedef struct {
    znumber n;
    znumber d;
} qnumber;

#define zcopy(x,y) (*(y)=(*(x)))
#define qcopy(x,y) (*(y)=(*(x)))
#define zcmp(x,y) zgle(x,y)
#define qcmp(x,y) qgle(x,y)
#define ziszero(x) (!(x)->len)
#define qiszero(x) ziszero(&(x)->n)
#define qsgn(x) zsgn(&(x)->n)
#define qchs(x) zchs(&(x)->n)

void zzero(znumber *);
int zsgn(znumber *);
void zchs(znumber *);
void znorm(znumber *);
void zset(znumber *, long);
void zadd(znumber *, znumber *, znumber *);
void zsub(znumber *, znumber *, znumber *);
void zmul(znumber *, short, znumber *);
void zmulu(znumber *, unsigned short, znumber *);
void zzmul(znumber *, znumber *, znumber *);
void zdiv(znumber *, short, znumber *, int *);
void zdivu(znumber *, unsigned short, znumber *, int *);
void zzdiv(znumber *, znumber *, znumber *, znumber *);
int zgle(znumber *, znumber *);
int zglem(znumber *, znumber *);
void zprintv(znumber *);
char *ztodec(znumber *);
void dectoz(char [], znumber *, char **);
double ztof(znumber *);
void qzero(qnumber *);
void qreduce(qnumber *);
void ztoq(znumber *, qnumber *);
void zztoq(znumber *, znumber *, qnumber *);
void qnorm(qnumber *);
void qset(qnumber *, long, long);
void qadd(qnumber *, qnumber *, qnumber *);
void qsub(qnumber *, qnumber *, qnumber *);
void qmul(qnumber *, short, qnumber *);
void qmulu(qnumber *, unsigned short, qnumber *);
void qqmul(qnumber *, qnumber *, qnumber *);
void qdiv(qnumber *, short, qnumber *);
void qdivu(qnumber *, unsigned short, qnumber *);
void qqdiv(qnumber *, qnumber *, qnumber *);
void qinv(qnumber *, qnumber *);
int qgle(qnumber *, qnumber *);
int qglem(qnumber *, qnumber *);
void qprintv(qnumber *);
char *qtodec(qnumber *);
void dectoq(char [], qnumber *, char **);
double qtof(qnumber *);

/*
void zzero(znumber *);
int zsgn(znumber *);
void zchs(znumber *);
void znorm(znumber *);
void zset(znumber *, long);
void zadd(znumber *, znumber *, znumber *);
void zsub(znumber *, znumber *, znumber *);
void zmul(znumber *, short, znumber *);
void zmulu(znumber *, unsigned short, znumber *);
void zzmul(znumber *, znumber *, znumber *);
void zdiv(znumber *, short, znumber *, int *);
void zdivu(znumber *, unsigned short, znumber *, int *);
void zzdiv(znumber *, znumber *, znumber *, znumber *);
int zgle(znumber *, znumber *);
int zglem(znumber *, znumber *);
void zprintv(znumber *);
char *ztodec(znumber *);
double ztof(znumber *);
*/
/*
void zzero();
int zsgn();
void zchs();
void znorm();
void zset();
void zadd();
void zsub();
void zmul();
void zmulu();
void zzmul();
void zdiv();
void zdivu();
void zzdiv();
int zgle();
int zglem();
void zprintv();
char *ztodec();
double ztof();
void qzero();
void qreduce();
void ztoq();
void zztoq();
void qnorm();
void qset();
void qadd();
void qsub();
void qmul();
void qmulu();
void qqmul();
void qdiv();
void qdivu();
void qqdiv();
void qinv();
int qgle();
int qglem();
void qprintv();
char *qtodec();
double qtof();
*/
