#include <stdio.h>
#include "fixed.h"

void mealg(znumber *u, znumber *v, znumber *f, znumber *d, znumber *c)
{
    znumber a, b, e, r, s, t, tt;

    zzero(&a);
    zzero(d);
    zset(&b,1);
    zset(c,1);
    zcopy(u,&e);
    zcopy(v,f);
    while (!ziszero(&e)) {
	zzdiv(f, &e, &s, &r);
	zcopy(&a,&t);
	zzmul(&s,&a,&tt);
	zsub(c,&tt,&a);
	zcopy(&t,c);
	zcopy(&b,&t);
	zzmul(&s,&b,&tt);
	zsub(d,&tt,&b);
	zcopy(&t,d);
	zcopy(&e,f);
	zcopy(&r,&e);
    }
    if (zsgn(f) < 0) {
	zchs(f);
	zchs(d);
	zchs(c);
    }
}

void mgcd(znumber *u, znumber *v, znumber *f)
{
    znumber e, r, s;

    zcopy(u,&e);
    zcopy(v,f);
    while (!ziszero(&e)) {
	zzdiv(f, &e, &s, &r);
	zcopy(&e,f);
	zcopy(&r,&e);
    }
    if (zsgn(f) < 0)
	zchs(f);
}

#ifdef DEBUG
main()
{
    znumber x, y, z, w, g, gg, h1, h2;
    int s0, s1, s2;

    while (1) {
	scanf("%d %d %d %d", &x.sign, &s2, &s1, &s0);
	x.s[0] = s0;
	x.s[1] = s1;
	x.s[2] = s2;
	x.len = 3;
	scanf("%d %d %d %d", &y.sign, &s2, &s1, &s0);
	y.s[0] = s0;
	y.s[1] = s1;
	y.s[2] = s2;
	y.len = 3;
	znorm(&x);
	znorm(&y);
	mealg(&x, &y, &g, &z, &w);
	mgcd(&x, &y, &gg);
	if (zcmp(&g, &gg))
	    printf("ERROR!  mgcd working improperly\n");
	printf(" (%s)", ztodec(&z));
	printf(" (%s)", ztodec(&x));
	printf("  +  (%s)", ztodec(&w));
	printf(" (%s)", ztodec(&y));
	printf("  =  %s", ztodec(&g));
	zzmul(&x, &z, &h1);
	zzmul(&y, &w, &h2);
	zadd(&h1, &h2, &gg);
	printf("    %s\n", zcmp(&g, &gg) ? "NO" : "yes");
    }
}
#endif
